from typing import List, Tuple

class ICompiledStepperMotorPlan:
    @property
    def start_time_ns(self) -> int: ...
    @property
    def end_time_ns(self) -> int: ...
    @property
    def start_pos(self) -> Tuple[int, float]: ...
    @property
    def end_pos(self) -> Tuple[int, float]: ...
    def get_pos(self, cur_time_ns: int) -> Tuple[int, float]: ...
    def compute(self, cur_time_ns: int) -> Tuple[int, int]: ...

class IFrozenStepperMotorPlan:
    @property
    def start_time_ns(self) -> int: ...
    @property
    def end_time_ns(self) -> int: ...
    @property
    def start_pos(self) -> Tuple[int, float]: ...
    @property
    def end_pos(self) -> Tuple[int, float]: ...
    def get_pos(self, cur_time_ns: int) -> Tuple[int, float]: ...
    def compile(self, cur_time_ns: int, cur_pos: Tuple[int, float]) -> ICompiledStepperMotorPlan: ...

class Plan:
    def freeze(self, start_time_ns: int, start_pos: Tuple[int, float], warmup_k: float) -> IFrozenStepperMotorPlan: ...

class FrozenStepperMotorSimplePlan(IFrozenStepperMotorPlan):
    @property
    def start_vel(self) -> float: ...
    @property
    def end_vel(self) -> float: ...

class SimplePlan(Plan):
    @property
    def start_vel(self) -> float: ...
    @property
    def end_vel(self) -> float: ...
    @property
    def duration(self) -> float: ...
    def __init__(self, start_vel: float, end_vel: float, duration: float) -> None: ...
    def freeze(
        self, start_time_ns: int, start_pos: Tuple[int, float], warmup_k: float
    ) -> FrozenStepperMotorSimplePlan: ...

class FrozenStepperMotorGroupPlan(IFrozenStepperMotorPlan):
    pass

class GroupPlan(Plan):
    @property
    def plans(self) -> List[Plan]: ...
    def __init__(self, plans: List[Plan]) -> None: ...
    def freeze(
        self, start_time_ns: int, start_pos: Tuple[int, float], warmup_k: float
    ) -> FrozenStepperMotorGroupPlan: ...
